con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
_INIT           =   $FFAA 'INITIALIZE COPROCESSOR
_ERRORS         =   $FE 'Get Error Flags
_LOW            =   $B0 'SET PIN OUTPUT LOW
_HIGH           =   $B1 'SET PIN OUTPUT HIGH
_INPUT          =   $B2 'SET PIN TO INPUT
_INPUTP         =   $B6 'SET PIN TO INPUT WITH PULLUP
_PUSH           =   $D0 'PUSH ONE BYTE ON STACK at the current sram pointer and increment pointer
_POP            =   $D1 'decrement sram pointer and POP ONE BYTE OFF STACK
_ZSTACK         =   $D2 'ZERO THE STACK POINTER
_CLRBL          =   $B7 'CLEAR THE BLATCH REGISTER
_CLRCL          =   $B8 'CLEAR THE CLATCH REGISTER

_RPINSA         =   $C0 'READ PINS  0...5
_RPINSB         =   $C1 'READ PINS  6..11
_RPINSC         =   $C2 'READ PINS 12..18
_PINSBL         =   $C3 'READ LATCHED LOW PINS   6..11
_PINSCL         =   $C4 'READ LATCHED HIGH PINS 12..18
_SECONDS        =   $C5 'Read seconds
_MINUTES        =   $C6 'Read Minutes
_HOURS          =   $C7 'Read Hours
_DAYS           =   $C8 'Read Days
_TIME           =   $C9 'Read seconds,minutes,hours
_ADC0           =   $A0 'READ ADC0
_ADC1           =   $A1 'READ ADC1
_ADC2           =   $A2 'READ ADC2
_ADC3           =   $A3 'READ ADC3
_ADC4           =   $A4 'READ ADC4

_WRITEFLASH     =   $D3 'write 255 bytes from SRAM to FLASH memory
_READFLASH      =   $D4 'Read 255 bytes from FLASH to SRAM memory
_Readsram       =   $D5 'Read a byte at the current sram pointer and increment pointer
_setstack       =   $D6 'Set the Sram pointer
_EWRITE         =   $D7 'wRITE A BYTE TO EEPROM
_EREAD          =   $D8 'Read  a byte from EEPROM
_SETTIME        =   $D9 'Set seconds,minutes,hours,days



Dpin            =  9
Cpin            =  8               
Mode            =  1
obj
  BS : "Bs2_Functions"
  com : "PC_Debug"
var
  long  Reading
  long  Control
  Byte  page      
  Word  TEMP    
  Byte  BUFFER    
  Byte  Seconds   
  Byte  Minutes   
  Byte  Hours    
  Byte  days      
  Byte  Address
  byte  Bits 
pub Main
  waitcnt((Clkfreq*2)+cnt)
  com.start(115200) 
  'Initialize Coprocessor
  bs.SHIFTOUT (Dpin,Cpin,_INIT,Mode,16) 
  bits := 8
  SetTime
  PinTest
  StackTest
  TestEEPROM 
pub ADC  
  reading := com.in  'Waits for key press before starting readings
  repeat
    bs.SHIFTOUT (Dpin,Cpin,_ADC4,Mode,8)
    waitcnt((Clkfreq/1000)+cnt)
    Reading := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
    com.dec(Reading)
    com.crlf
    waitcnt((Clkfreq/2)+cnt)
pub Servo
  Reading := 900
  dira[15]~~
  repeat
    outa[15]~~
    waitcnt((Clkfreq/Reading)+cnt)
    outa[15]~
    waitcnt((Clkfreq/100)+cnt)
   com.dec(reading)
   control := com.in
   com.newline 
    if control == 45
      Reading-=50
    elseif control == 43
      reading+=50
    else
      reading~
   if reading > 3000
    reading := 3000
   if reading < 400
      if !reading == 0
        reading := 400
pub setTime  | Value
          'settime seconds,minutes,hours,days
'SHIFTOUT 0,1,1,[_SETTIME,58,59,23,255]
Value :=  _SETTIME
bs.SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)
Value :=  58
bs.SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)
Value :=  59
bs.SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)
Value :=  23
bs.SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)
Value :=  255
bs.SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)
pub PinTest 
repeat until reading == 1
  bs.SHIFTOUT (Dpin, Cpin,_MINUTES, Mode, Bits)
  Reading := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
  com.str(String("Minutes equals "))
  waitcnt((Clkfreq*5)+cnt)
  com.dec(reading)  
  com.crlf
repeat temp from 17 to 0
  bs.SHIFTOUT (Dpin, Cpin, _HIGH, Mode, Bits)
  bs.SHIFTOUT (Dpin, Cpin, temp, Mode, Bits)
  waitcnt((clkfreq*2)+cnt)
  bs.SHIFTOUT (Dpin, Cpin, _LOW, Mode, Bits)
  bs.SHIFTOUT (Dpin, Cpin, temp, Mode, Bits)
  waitcnt((clkfreq*2)+cnt)
  com.str(String("Pin Toggled was "))
  com.dec(temp)
  com.crlf
  com.str(String("Seconds equals "))
  bs.SHIFTOUT (Dpin, Cpin,_SECONDS, Mode, Bits)
  Reading := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
  com.dec(Reading)
  com.crlf
Pub TestEEPROM
 bs.SHIFTOUT (Dpin, Cpin,_MINUTES, Mode, Bits)
 Reading := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
 com.str(String("Starting EEPROM Test"))
 com.crlf  
 com.str(String("Minutes equals "))
 waitcnt((Clkfreq)+cnt)
 com.dec(reading)  
 com.crlf
TEMP:=10
repeat Address from 0 to 10
  bs.SHIFTOUT (Dpin, Cpin,_EWRITE, Mode, Bits)
  bs.SHIFTOUT (Dpin, Cpin,Address, Mode, Bits)
  bs.SHIFTOUT (Dpin, Cpin,TEMP--, Mode, Bits)
  waitcnt((clkfreq)+cnt)
  bs.SHIFTOUT (Dpin, Cpin,_EREAD, Mode, Bits)
  bs.SHIFTOUT (Dpin, Cpin,Address, Mode, Bits)
  buffer := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
  com.str(String("The eeprom address "))
  com.DEC(Address)
  com.str(String(" = "))
  com.DEC(buffer)
  waitcnt((clkfreq)+cnt)
  com.crlf
pub StackTest  | i
 bs.SHIFTOUT (Dpin, Cpin,_MINUTES, Mode, Bits)
 Reading := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
 com.str(String("Starting Stack Test"))
 com.crlf  
 com.str(String("Minutes equals "))
 waitcnt((Clkfreq)+cnt)
 com.dec(reading)  
 com.crlf
repeat i from $AA to $55
'Push a byte on the stack
  bs.SHIFTOUT (Dpin, Cpin,_PUSH, Mode, Bits)
  bs.SHIFTOUT (Dpin, Cpin,i, Mode, Bits)
'Pop a byte from the stack
repeat i from $AA to $55
  bs.SHIFTOUT (Dpin, Cpin,_POP, Mode, Bits)
  buffer := bs.shiftin (Dpin, Cpin,BS#MSBPRE,8)
  waitcnt((clkfreq)+cnt)
  com.dec(buffer)
  com.crlf 
